function love.run()
end
local frame_limiter =require("scripts.frame_limiter")
local showlegend = true
local fpslimit = 300 --engine/limiter
local textimput =require("scripts.textimput")
local disptextimput = false
local mtatl=require("scripts.timer")
local utility = require("scripts.utility")
local screan_setup = require("scripts.screan_setup")
local world_setup = require("scripts.world_setup")
local texture_setup = require("scripts.texture_setup")
local raycast_lib = require("scripts.raycasting")
local screan = screan_setup.load(640,400)
local world = world_setup.load()
local texture = texture_setup.load()
local raycast = raycast_lib.load()
texture_setup.aplay(world,0,texture)
raycast_lib.setupfloor(raycast,screan,texture)

local dirinfo = {
[270] = {d="u",l=180,r=360,is={true,false,false,false}},
[0] = {d="r",l=270,r=90,is={false,false,false,true}},
[360] = {d="r",l=270,r=90,is={false,false,false,true}},
[180] = {d="l",l=90,r=270,is={false,false,true,false}},
[90] = {d="d",l=0,r=180,is={false,true,false,false}},
} --controlls

local pla = {
	atype = "pla",
	grid_x = 2*32+16,
	grid_y = 2*32+16,
	act_x = 2*32+16,
	act_y = 2*32+16,
	speed = 2,
	r=0,
	ismoving = {x=false,y=false,overal=false,overalstate=true},
	g_r = 0,
	dir = "r",
	ll=false,
	rr=false,
	uu=false,
	dd=false,
	sl=false,
	sr=false
} --entity
local bots = {} --entity
for i=1,10 do --entity
	bots[i] = {
		atype = "bot",
		subtype = "",
		alive = true,
		i = 1,
		spawn_x= 5*32+16,
		spawn_y= 5*32+16,
	    	grid_x = 5*32+16,
       		grid_y = 5*32+16,
       		act_x = 5*32+16,
       		act_y = 5*32+16,
		ismoving = {x=false,y=false,overal=false,overalstate=true},
		draw_x = 0,
       		draw_y = 0,
       		speed = 1,
	   	r = 0,
		g_r = 0,
		dir = "r",
		visible = true,
		comp = "calc",
		dynamic = 0,
		prevdynamic = 0,
		animtime = 0.2,
		curanimtime = 0.2,
		animstate = 0,
		maxanimstate = 2
        }
end

function createchest(x,y,r) --entity
	world.map[y][x].col = 10
	return {
		atype = "chest",
		act_x = x*32+16,
       		act_y = y*32+16,
		r = r,
		visible = true,
		animstate = 0,
	}
end

local chests = {}
for i=1,#world.static_spawn do
	chests[(world.static_spawn[i].y-1)*#world.map[1]+world.static_spawn[i].x] = createchest(world.static_spawn[i].x,world.static_spawn[i].y,90*i)
end

local mapdraw = love.graphics.newCanvas(320,200) --hud
function rendernewmap() --hud
	mapdraw:clear()
	love.graphics.setColor(255,255,255)
	mapdraw:renderTo( function()
		for y=1,#world.map do
			for x=1,#world.map[1] do
				if world.map[y][x].col == 1 then
					love.graphics.rectangle("fill",32+x*8,32+y*8,8,8)
				end
			end
		end
	end )
end
rendernewmap() --hud

function setisplayermowing(elem,state,dir) --engine/AI
    if elem.ismoving then
	elem.ismoving[dir] = state
	elem.ismoving.overal = (elem.ismoving.x  or elem.ismoving.y)
   end
end

function rotateElement(p,dt) --engine/AI
	local g_r = p.g_r
	if p.atype == "bot" then
		g_r = p.g_r*90
	end
	if p.dir == "l" then
		p.r=p.r-dt*3*32
		if p.r <= 0 then
			g_r = 360
		end
		if p.r <= g_r then
			p.r = g_r
		end
	else
		p.r=p.r+dt*3*32
		if p.r >= 360 then
			g_r = 0
		end
		if p.r >= g_r then
			p.r = g_r
		end
	end
	if p.atype == "bot" then
		p.g_r = g_r/90
	else
		p.g_r = g_r
	end
end

function moveElement(elem,dt,dir) -- engine
   if not dir then
	moveElement(elem,dt,"x")
	moveElement(elem,dt,"y")
   else
  	 if elem["act_"..dir] - elem["grid_"..dir] < 2*(32*elem.speed*dt) and elem["grid_"..dir] - elem["act_"..dir] < 2*(32*elem.speed*dt) then
 	     elem["act_"..dir] = elem["grid_"..dir]
	     setisplayermowing(elem,false,dir)
 	  elseif not (elem["act_"..dir] - elem["grid_"..dir] < 2*(32*elem.speed*dt)) then
 	     elem["act_"..dir] = elem["act_"..dir] - 32*elem.speed*dt
	     setisplayermowing(elem,true,dir)
 	  elseif not (elem["grid_"..dir] - elem["act_"..dir] < 2*(32*elem.speed*dt)) then
 	     elem["act_"..dir] = elem["act_"..dir] + 32*elem.speed*dt
	     setisplayermowing(elem,true,dir)
 	  end
   end
end

function moveGrid(elem,dir1,dir2,dir3,dir4) -- engine
	if elem.act_y == elem.grid_y and elem.act_x == elem.grid_x  then
        	elem["grid_"..dir1] = elem["grid_"..dir1] + dir2
	end
end


function testBotMap(p,x,y) --engine/controlls
	local px,py = (p.grid_x -16)/32,(p.grid_y -16)/32
	if world.map[py+y][px+x].col >0 then
		return false
	end
	return true
end

function testMonsterMap(bot,dirlst) --AI
	local validdirtab = {}
	local blocked = true
	for i=1,3 do
		local x,y = dirlst[i].x,dirlst[i].y
		if world.map[(bot.grid_y-16)/32+y][(bot.grid_x-16)/32+x].col == 0 and not world.dynamicmap[((bot.grid_y-16)/32+y-1)*#world.map[1]+(bot.grid_x-16)/32+x] and not world.prevdynamicmap[((bot.grid_y-16)/32+y-1)*#world.map[1]+(bot.grid_x-16)/32+x] then 
			blocked = false
			validdirtab[#validdirtab+1] = dirlst[i]
		end
	end
	if blocked then
		if bot.g_r == 0 and dirlst[4].dirid == "l" then
			bot.r = 360
		end
		if bot.g_r == 4 and dirlst[4].dirid == "r" then
			bot.r = 0
		end
		bot.g_r = dirlst[4].dir
		bot.dir = dirlst[4].dirid
	else
		local rand = math.random(1,#validdirtab)
		if bot.g_r == 0 and validdirtab[rand].dirid == "l" then
			bot.r = 360
		end
		if bot.g_r == 4 and validdirtab[rand].dirid == "r" then
			bot.r = 0
		end
		bot.g_r = validdirtab[rand].dir
		bot.dir = validdirtab[rand].dirid
	end
	
end
local rendernum = 0 --engine-draw

local tempdt = 0 --engine/limiter
local tempdttodisplay = 0 --engine/hud/limiter
local botdecisionset = {[0]={{x=0,y=-1,dir=0,dirid="r"},{x=1,y=0,dir=1,dirid="r"},{x=-1,y=0,dir=3,dirid="l"},{x=0,y=1,dir=2,dirid="r"}},[2]={{x=0,y=1,dir=2,dirid="r"},{x=-1,y=0,dir=3,dirid="r"},{x=1,y=0,dir=1,dirid="l"},{x=0,y=-1,dir=0,dirid="l"}},[3]={{x=-1,y=0,dir=3,dirid="r"},{x=0,y=-1,dir=4,dirid="r"},{x=0,y=1,dir=2,dirid="l"},{x=1,y=0,dir=1,dirid="l"}},[1]={{x=1,y=0,dir=1,dirid="r"},{x=0,y=1,dir=2,dirid="r"},{x=0,y=-1,dir=0,dirid="l"},{x=-1,y=0,dir=3,dirid="r"}},[4]={{x=0,y=-1,dir=4,dirid="l"},{x=1,y=0,dir=1,dirid="r"},{x=-1,y=0,dir=3,dirid="l"},{x=0,y=1,dir=2,dirid="l"}}} -- AI/cintrolls - utility?
function love.update(dt)
	mtatl.timerUpdate(dt)
     --[[ --timer
     tempdt = tempdt + dt --engine/limiter
     if tempdt >= 1/fpslimit then --engine/limiter
	dt = tempdt --engine/limiter
	tempdttodisplay = math.floor(1/tempdt) --engine/limiter
	tempdt = 0 --engine/limiter]]
	--point = {} --raycasting
	if pla.act_y ~= pla.grid_y or pla.act_x ~= pla.grid_x  then --engine/controlls
		moveElement(pla,dt)
	end
	if pla.r ~= pla.g_r then --engine/controlls
		rotateElement(pla,dt)
	end
	if pla.r == pla.g_r and (not pla.ismoving.overal) then --engine/controlls
    		if pla.uu then
			if dirinfo[pla.g_r].is[1] and testBotMap(pla,0, -1) then moveGrid(pla,"y",-32,0,1) 
    			elseif dirinfo[pla.g_r].is[2] and testBotMap(pla,0, 1) then moveGrid(pla,"y",32,0,-1) 
    			elseif dirinfo[pla.g_r].is[3] and testBotMap(pla,-1, 0) then moveGrid(pla,"x",-32,1,0) 
    			elseif dirinfo[pla.g_r].is[4] and testBotMap(pla,1, 0) then moveGrid(pla,"x",32,-1,0)  end
		end
		if pla.dd then
			if dirinfo[pla.g_r].is[2] and testBotMap(pla,0, -1) then moveGrid(pla,"y",-32,0,1) 
    			elseif dirinfo[pla.g_r].is[1] and testBotMap(pla,0, 1) then moveGrid(pla,"y",32,0,-1) 
    			elseif dirinfo[pla.g_r].is[4] and testBotMap(pla,-1, 0) then moveGrid(pla,"x",-32,1,0) 
    			elseif dirinfo[pla.g_r].is[3] and testBotMap(pla,1, 0) then moveGrid(pla,"x",32,-1,0) end
		end
		if pla.sl then
			if dirinfo[pla.g_r].is[4] and testBotMap(pla,0, -1) then moveGrid(pla,"y",-32,0,1) 
    			elseif dirinfo[pla.g_r].is[3] and testBotMap(pla,0, 1) then moveGrid(pla,"y",32,0,-1) 
    			elseif dirinfo[pla.g_r].is[1] and testBotMap(pla,-1, 0) then moveGrid(pla,"x",-32,1,0) 
    			elseif dirinfo[pla.g_r].is[2] and testBotMap(pla,1, 0) then moveGrid(pla,"x",32,-1,0)  end
		end
		if pla.sr then
			if dirinfo[pla.g_r].is[3] and testBotMap(pla,0, -1) then moveGrid(pla,"y",-32,0,1) 
    			elseif dirinfo[pla.g_r].is[4] and testBotMap(pla,0, 1) then moveGrid(pla,"y",32,0,-1) 
    			elseif dirinfo[pla.g_r].is[2] and testBotMap(pla,-1, 0) then moveGrid(pla,"x",-32,1,0) 
    			elseif dirinfo[pla.g_r].is[1] and testBotMap(pla,1, 0) then moveGrid(pla,"x",32,-1,0)  end
		end
		if pla.ll then
			pla.g_r = dirinfo[pla.g_r].l
			pla.dir = "l"
		end
		if pla.rr then
			pla.g_r = dirinfo[pla.g_r].r
			pla.dir = "r"
		end
	end
	raycast_lib.updateA(dt,screan,world,raycast,pla,utility)
	for i,bot in pairs(bots) do --engine/AI
	  if bot.alive then
		if not bot.ismoving.overal and bot.r == bot.g_r*90 and bot.act_y == bot.grid_y and bot.act_x == bot.grid_x then
			
			testMonsterMap(bot,botdecisionset[bot.g_r])
			
			if bot.g_r == 0 then moveGrid(bot,"y",-32,0,1)
			elseif bot.g_r == 2 then moveGrid(bot,"y",32,0,-1)
			elseif bot.g_r == 3 then moveGrid(bot,"x",-32,1,0)
			elseif bot.g_r == 1 then moveGrid(bot,"x",32,-1,0) 
			elseif bot.g_r == 4 then moveGrid(bot,"y",-32,0,1) end
			--bot.speed = flormomsters[1][bot.subtype][2]
			world.prevdynamicmap[bot.prevdynamic] = nil
			world.prevdynamicmap[bot.dynamic] = dynamicmap[bot.dynamic]
			bot.prevdynamic = bot.dynamic
			world.dynamicmap[bot.dynamic] = nil
			world.dynamicmap[((bot.grid_y-16)/32-1)*#world.map[1]+(bot.grid_x-16)/32] = bot
			bot.dynamic = ((bot.grid_y-16)/32-1)*#world.map[1]+(bot.grid_x-16)/32
			
			
			
		end
		if bot.curanimtime > 0 then
			bot.curanimtime = bot.curanimtime - dt
		else
			bot.curanimtime = bot.animtime
			bot.animstate = bot.animstate + 1
			if bot.animstate > bot.maxanimstate then
				bot.animstate = 0
			end
		end
		local xinc = bot.act_y-pla.act_y
		local yinc = bot.act_x-pla.act_x
		local radang = math.floor(math.deg(math.atan2(xinc,yinc))*screan.subang)
		if radang < 0 then
			radang = radang + 360*screan.subang
		end
		local imgangle = pla.r-bot.r-90
		if imgangle < -360 then
			imgangle = imgangle + 2*360
		elseif imgangle < 0 then
			imgangle = imgangle + 360
		end
		local imgid = math.floor((imgangle)/45)
		if raycast.temppoint[radang] then
			raycast.point[#raycast.point+1] = {x=0 or 0,y=0 or 0,d=32/(utility.distance(pla.act_y,pla.act_x,bot.act_y,bot.act_x)*raycast.temppoint[radang].cos)*screan.camdist or 0,dir="f",c=0,id=raycast.temppoint[radang].id,img=texture.ratimgT[bot.animstate][imgid] or texture.ratimgT[0][0],bot=bot,img2=texture.ratimg}
		end
		if (bot.act_y ~= bot.grid_y or bot.act_x ~= bot.grid_x) then
			if bot.r == bot.g_r*90 then
				moveElement(bot,dt)
			else
				rotateElement(bot,dt)
			end
		end
		
	  end
		    
	end
	for i,c in pairs(chests) do --entity/statics
		local xinc = c.act_y-pla.act_y
		local yinc = c.act_x-pla.act_x
		local radang = math.floor(math.deg(math.atan2(xinc,yinc))*screan.subang)
		if radang < 0 then
			radang = radang + 360*screan.subang
		end
		local imgangle = pla.r-c.r-90
		if imgangle < -360 then
			imgangle = imgangle + 2*360
		elseif imgangle < 0 then
			imgangle = imgangle + 360
		end
		local imgid = math.floor((imgangle)/45)
		if raycast.temppoint[radang] then
			raycast.point[#raycast.point+1] = {x=0 or 0,y=0 or 0,d=32/((utility.distance(pla.act_y,pla.act_x,c.act_y,c.act_x)-10)*raycast.temppoint[radang].cos)*screan.camdist or 0,dir="f",c=0,id=raycast.temppoint[radang].id,img=texture.chestimgT[c.animstate][imgid] or texture.ratimgT[0][0],chest=c,img2=texture.chestimg}
		end
--	end
	
	raycast_lib.updateB(dt,screan,texture,raycast,pla,heapsortfunc)	
   
  end
  if disptextimput then
	textimput.update(dt)
  end
end

function love.draw()
	
	love.graphics.setColor(255,255,255)-- level-draw
	local nfpoint = 0
	local ncpoint = 0
	local nwpoint = screan.h_w
	local nspr = 0
	for i=1, #raycast.fpoint do
		if raycast.fpoint[i].i < raycast.rendernum then
			local lightcolor = math.max(math.min(math.floor(raycast.fpoint[i].l+texture.light_l),255),0)
			love.graphics.setColor(lightcolor,lightcolor,lightcolor)
			if texture.disp_s.f then
				
				love.graphics.draw(texture.fullfloortodraw, texture.fullfloortodrawQuad[raycast.fpoint[i].i], screan.h_w-raycast.fpoint[i].sc, raycast.fpoint[i].y, 0,raycast.fpoint[i].d ,raycast.fpoint[i].scx , 0, 0, 0, 0 )
			end
			nfpoint = nfpoint + 1
		end
	end
	for i=1, #raycast.cpoint do
		if raycast.cpoint[i].i < raycast.rendernum then	
			local lightcolor = math.max(math.min(math.floor(raycast.cpoint[i].l+texture.light_l),255),0)
			love.graphics.setColor(lightcolor,lightcolor,lightcolor)
			if texture.disp_s.c then
				love.graphics.draw(texture.fullceltodraw, texture.fullceltodrawQuad[raycast.cpoint[i].i], screan.h_w-raycast.cpoint[i].sc, raycast.cpoint[i].y2, 0,raycast.cpoint[i].d ,raycast.cpoint[i].scx , 0, 0, 0, 0 )
			end
			ncpoint = ncpoint + 1
		end
	end
	
	for i = 1,#raycast.point do
		local lightcolor = math.max(math.min(math.floor(raycast.point[i].d+texture.light_l),255),0)
		love.graphics.setColor(lightcolor,lightcolor,lightcolor)
		
		local x = raycast.point[i].id*2 
		local y1 = screan.c_h + raycast.point[i].d/2
		local y2 = screan.c_h*2 - raycast.point[i].d + raycast.vm.w*raycast.point[i].d/50 + raycast.vm.d3
		if raycast.point[i].dir == "f" then
			love.graphics.draw(raycast.point[i].img2,raycast.point[i].img, x-raycast.point[i].d, y2, 0, raycast.point[i].d/32, raycast.point[i].d/32, 0, 0, 0, 0)
		  
		elseif raycast.point[i].dir == "x" and texture.disp_s.w then 
			love.graphics.draw( texture.textures, texture.slicewallimg[(64-raycast.point[i].c)+64*world.map[raycast.point[i].y][raycast.point[i].x].x] or texture.slicewallimg[1+64*world.map[point[i].y][raycast.point[i].x].x], x, y2, 0, 2, (raycast.point[i].d)/32, 0, 0, 0, 0 )
		elseif texture.disp_s.w then
			love.graphics.draw( texture.textures, texture.slicewallimg[(64-raycast.point[i].c)+64*world.map[raycast.point[i].y][raycast.point[i].x].y] or texture.slicewallimg[1+64*world.map[point[i].y][raycast.point[i].x].y], x, y2, 0, 2, (raycast.point[i].d)/32, 0, 0, 0, 0 )
		end
		nspr = nspr + 1
	end

	love.graphics.setColor(255,0,0) -- hud-draw
	love.graphics.printf("FPS: "..love.timer.getFPS().."; FPS limit: "..fpslimit.."; rendering: floor= "..nfpoint..", celing="..ncpoint..", wall="..nwpoint..", sprite="..nspr-nwpoint..", overal="..nfpoint+ncpoint+nspr.."; Light="..texture.light_l.."; tilt ="..raycast.vm.d3.."; elevation="..raycast.vm.w,5,5,screan.w-10)
	love.graphics.draw(mapdraw,0,0)
	love.graphics.circle("fill",32+pla.act_x/4,32+pla.act_y/4,3)
	love.graphics.setColor(0,255,0,100)
	
	love.graphics.setColor(0,0,255,255)
	
	for i,bot in pairs(bots) do
		love.graphics.circle("fill",32+bot.act_x/4,32+bot.act_y/4,3)
	end
	if disptextimput then
		textimput.draw(screan)
  	end
	if showlegend then
		love.graphics.setColor(0,0,0,255)
		love.graphics.rectangle("fill",20,20,screan.w-40,screan.h-40)
		love.graphics.setColor(255,255,255,255)
		love.graphics.printf([[Legend:
			Read dot on minimap = player
			Blue dot on minimap = bot
			FPS = Frames per second
			CPS = calculations per second (game tics per second)
			Rendering = amount of images drawn on the screen
			Light = lighting modifier
			Tilt = player head tilt
			Elevation = player eye elevation
			Keys: 
			Move = arrow keys or q,w,e,a,s,d
			Interact = space
			Textures= 1,2,3,4
			Resolution = r
			Lighting = '-','='
			Elevation = num+, num-
			Tilt = num/, num*
			CPS limit = num1,num2
			Toggling wall, ceiling, floor = 8,9,0
			Toggling the legend = esc]],30,30,screan.w-30)
	end
end
local newW= 0
function getscreenheight(scr_H)
	disptextimput = false
	screan = screan_setup.load(tonumber(newW),tonumber(scr_H))
	texture_setup.aplay(world,0,texture)
	raycast_lib.setupfloor(raycast,screan,texture)
	rendernewmap()
end
function getscreenwight(scr_w)
	newW = scr_w
	local keytab = {"1","2","3","4","5","6","7","8","9","0","kp1","kp2","kp3","kp4","kp5","kp6","kp7","kp8","kp9","kp0",}
	local morespecialkeytab ={["kp1"]="1",["kp2"]="2",["kp3"]="3",["kp4"]="4",["kp5"]="5",["kp6"]="6",["kp7"]="7",["kp8"]="8",["kp9"]="9",["kp0"]="0",}
	textimput.setup(getscreenheight,keytab,morespecialkeytab,"Enter screen height",3,4)
end

function love.keypressed(key) --controlls
    if disptextimput then
	textimput.key(key)
    else
	if key == "left" then
    		pla.ll = true
	elseif key == "right" then
    		pla.rr = true
	elseif key == "up" then
    		pla.uu = true
	elseif key == "down" then
    		pla.dd = true
	elseif key == "a" then
    		pla.ll = true
	elseif key == "d" then
    		pla.rr = true
	elseif key == "w" then
    		pla.uu = true
	elseif key == "s" then
    		pla.dd = true
	elseif key == "q" then
    		pla.sl = true
	elseif key == "e" then
    		pla.sr = true
	elseif key == "1" then	
		texture_setup.aplay(world,1,texture)
	elseif key == "2" then	
		texture_setup.aplay(world,2,texture)
	elseif key == "3" then	
		texture_setup.aplay(world,3,texture)
	elseif key == "4" then	
		texture_setup.aplay(world,4,texture)
	elseif key == "-" then	
		local keyiter
		function keyiter()
			if love.keyboard.isDown("-") then
				texture.light_l = texture.light_l - 1
				mtatl.setTimer(keyiter,0.1,1)
			end
		end
		keyiter()
	elseif key == "=" then	
		local keyiter
		function keyiter()
			if love.keyboard.isDown("=") then
				texture.light_l = texture.light_l + 1 -- 
				mtatl.setTimer(keyiter,0.1,1)
			end
		end
		keyiter()
	elseif key == "8" then	
		texture_setup.update_s(texture,"w")
	elseif key == "9" then	
		texture_setup.update_s(texture,"f")
	elseif key == "0" then	
		texture_setup.update_s(texture,"c")
	elseif key == "kp+" then
		local keyiter
		function keyiter()
			if raycast.vm.w < 30 and love.keyboard.isDown("kp+") then	
				raycast.vm.w=raycast.vm.w+0.5
				raycast.vm.h=raycast.vm.h+0.16
				raycast.vm.d1=raycast.vm.d1+0.2
				raycast_lib.setupfloor(raycast,screan,texture)
				mtatl.setTimer(keyiter,0.1,1)
			end
		end
		keyiter()
	elseif key == "kp-" then
		local keyiter
		function keyiter()
			if raycast.vm.w > -30 and love.keyboard.isDown("kp-") then	
				raycast.vm.w=raycast.vm.w-0.5
				raycast.vm.h=raycast.vm.h-0.16
				raycast.vm.d1=raycast.vm.d1-0.2
				raycast_lib.setupfloor(raycast,screan,texture)
				mtatl.setTimer(keyiter,0.1,1)
			end
		end
		keyiter()
	elseif key == "kp*" then
		local keyiter
		function keyiter()
			if raycast.vm.d3 < 120 and love.keyboard.isDown("kp*") then	
				raycast.vm.d3=raycast.vm.d3+1
				raycast.vm.d1=raycast.vm.d1+1
				raycast.vm.d2=raycast.vm.d2-1
				raycast_lib.setupfloor(raycast,screan,texture)
				mtatl.setTimer(keyiter,0.05,1)
			end
		end
		keyiter()
	elseif key == "kp/" then
		local keyiter
		function keyiter()
			if raycast.vm.d3 > - 120 and love.keyboard.isDown("kp/") then	
				raycast.vm.d3=raycast.vm.d3-1
				raycast.vm.d1=raycast.vm.d1-1
				raycast.vm.d2=raycast.vm.d2+1
				raycast_lib.setupfloor(raycast,screan,texture)
				mtatl.setTimer(keyiter,0.05,1)
			end
		end
		keyiter()
	elseif key == "kp1" then
		local keyiter
		function keyiter()
			if raycast.vm.d3 < 120 and love.keyboard.isDown("kp1") then	
				fpslimit = fpslimit + 1
				frame_limiter.set(fpslimit)
				mtatl.setTimer(keyiter,0.8,1)
			end
		end
		keyiter()
	elseif key == "kp2" then
		local keyiter
		function keyiter()
			if raycast.vm.d3 > - 120 and love.keyboard.isDown("kp2") then	
				fpslimit = fpslimit - 1
				frame_limiter.set(fpslimit)
				mtatl.setTimer(keyiter,0.8,1)
			end
		end
		keyiter()
	elseif key == " " then
		local x,y = (pla.grid_x-16)/32 + botdecisionset[pla.g_r/90][2].x, (pla.grid_y-16)/32 + botdecisionset[pla.g_r/90][2].y
		if world.dynamicmap[(y-1)*#world.map[1]+x] or world.prevdynamicmap[(y-1)*#world.map[1]+x] then
			return
		elseif chests[(y-1)*#world.map[1]+x] then
			if chests[(y-1)*#world.map[1]+x].animstate == 0 then
				chests[(y-1)*#world.map[1]+x].animstate = 1
			else
				chests[(y-1)*#world.map[1]+x].animstate = 0
			end
		elseif not (y == 1 or y == #world.map or x == 1 or x == #world.map[1]) then
			if world.map[y][x].col == 1 then
				world.map[y][x].col = 0
			elseif world.map[y][x].col == 0 then
				world.map[y][x].col = 1
			end
			rendernewmap()
		end
	elseif key == "r" then
		disptextimput = true
		local keytab = {"1","2","3","4","5","6","7","8","9","0","kp1","kp2","kp3","kp4","kp5","kp6","kp7","kp8","kp9","kp0",}
		local morespecialkeytab={["kp1"]="1",["kp2"]="2",["kp3"]="3",["kp4"]="4",["kp5"]="5",["kp6"]="6",["kp7"]="7",["kp8"]="8",["kp9"]="9",["kp0"]="0",}
		textimput.setup(getscreenwight,keytab,morespecialkeytab,"Enter screen wight",3,4)
	elseif key == "escape" then
		showlegend = not showlegend	
	end
    end
end

function love.keyreleased(key) -- controlls
    if disptextimput then
	textimput.keyr(key)
    else
	if key == "left" then
    		pla.ll = false
	elseif key == "right" then
    		pla.rr = false
	elseif key == "up" then
    		pla.uu = false
	elseif key == "down" then
    		pla.dd = false
	elseif key == "a" then
    		pla.ll = false
	elseif key == "d" then
    		pla.rr = false
	elseif key == "w" then
    		pla.uu = false
	elseif key == "s" then
    		pla.dd = false
	elseif key == "q" then
    		pla.sl = false
	elseif key == "e" then
    		pla.sr = false	
	end
   end
end
function love.resize( w, h )
	screan = screan_setup.load(w,h)
	texture_setup.aplay(world,0,texture)
	raycast_lib.setupfloor(raycast,screan,texture)
	rendernewmap()
end
frame_limiter.run()